﻿using System;
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;
using ProjectSeaplane.DrawningObjects;
using ProjectSeaplane.Entities;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectSeaplane.Generics
{
    internal class DrawiningPlaneEqutables : IEqualityComparer<DrawningPlane?>
    {
        public bool Equals(DrawningPlane? x, DrawningPlane? y)
        {
            if (x == null || x.EntityPlane == null)
            {
                throw new ArgumentNullException(nameof(x));
            }
            if (y == null || y.EntityPlane == null)
            {
                throw new ArgumentNullException(nameof(y));
            }
            if (x.GetType().Name != y.GetType().Name)
            {
                return false;
            }
            if (x.EntityPlane.Speed != y.EntityPlane.Speed)
            {
                return false;
            }
            if (x.EntityPlane.Weight != y.EntityPlane.Weight)
            {
                return false;
            }
            if (x.EntityPlane.BodyColor != y.EntityPlane.BodyColor)
            {
                return false;
            }
            if (x is DrawningSeaplane && y is DrawningSeaplane)
            {
                EntitySeaplane _seplaneX = (EntitySeaplane)x.EntityPlane;
                EntitySeaplane _seplaneY = (EntitySeaplane)y.EntityPlane;
                if (_seplaneX.Boat != _seplaneY.Boat)
                {
                    return false;
                }
                if (_seplaneX.Floater != _seplaneY.Floater)
                {
                    return false;
                }
                if (_seplaneX.AdditionalColor != _seplaneY.AdditionalColor)
                {
                    return false;
                }
            }
            return true;
        }
        public int GetHashCode([DisallowNull] DrawningPlane obj)
        {
            return obj.GetHashCode();
        }

    }
}
