﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ProjectSeaplane.DrawningObjects;
using ProjectSeaplane.Entities;

namespace ProjectSeaplane.Generics
{
    internal class PlaneCompareByColor : IComparer<DrawningPlane?>
    {
        public int Compare(DrawningPlane? x, DrawningPlane? y)
        {
            if (x == null || x.EntityPlane == null)
            {
                throw new ArgumentNullException(nameof(x));
            }
            if (y == null || y.EntityPlane == null)
            {
                throw new ArgumentNullException(nameof(y));
            }
            if (x.EntityPlane.BodyColor.Name != y.EntityPlane.BodyColor.Name)
            {
                return x.EntityPlane.BodyColor.Name.CompareTo(y.EntityPlane.BodyColor.Name);
            }
            if (x.GetType().Name != y.GetType().Name)
            {
                if (x is DrawningPlane)
                    return -1;
                else
                    return 1;
            }
            if (x.GetType().Name == y.GetType().Name && x is DrawningSeaplane)
            {
                EntitySeaplane _seplaneX = (EntitySeaplane)x.EntityPlane;
                EntitySeaplane _seplaneY = (EntitySeaplane)y.EntityPlane;

                if (_seplaneX.AdditionalColor.Name != _seplaneY.AdditionalColor.Name)
                {
                    return _seplaneX.AdditionalColor.Name.CompareTo(_seplaneY.AdditionalColor.Name);
                }
            }

            var speedCompare = x.EntityPlane.Speed.CompareTo(y.EntityPlane.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return x.EntityPlane.Weight.CompareTo(y.EntityPlane.Weight);

        }
    }
}

