﻿using ProjectSeaplane.DrawningObjects;
namespace ProjectSeaplane.Generics
{
    internal class PlaneCompareByType : IComparer<DrawningPlane?>
    {
        public int Compare(DrawningPlane? x, DrawningPlane? y)
        {
            if (x == null || x.EntityPlane == null)
            {
                throw new ArgumentNullException(nameof(x));
            }
            if (y == null || y.EntityPlane == null)
            {
                throw new ArgumentNullException(nameof(y));
            }
            if (x.GetType().Name != y.GetType().Name)
            {
                return x.GetType().Name.CompareTo(y.GetType().Name);
            }
            var speedCompare = x.EntityPlane.Speed.CompareTo(y.EntityPlane.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return x.EntityPlane.Weight.CompareTo(y.EntityPlane.Weight);
        }
    }
}
